#!/usr/bin/python
"""

  Opens the given page and returns the specified
  number of article links (or all if the value is
  omitted.
  
  This code is covered by the GPLv2
 
  Written by R. Rawson-Tetley, 15th March 2005
  
"""

import urllib2
import sys
import string

desiredLinks = 99999
frontpage = "http://slashdot.org/"

# Arbitrary count back to find the " in a URL - this
# is a trick to save me implementing lastIndexOf in Python
lensl = len(frontpage) + 5

def printUsage():
	"""Outputs usage information."""
	print "SlashScrape: Scrape Slashdot for article links"
	print "Usage: slashscrape <frontpage> [number of links to return]"

def scrape():
	"""Scrapes the frontpage URL for the selected number of links."""

	# Verify the link has the http:// protocol bit on

	# Build a request object
	request = urllib2.Request(frontpage)

	# Get the page
	page = urllib2.urlopen(request)

	# Buffer the page into a string
	s = page.read()

	# Use an incremental counter to find all
	# of the available links
	i = string.find(s, "article.pl")
	linksOutput = 0
	while i != -1:

		sp = string.find(s, "\"", i - lensl) + 1
		ep = string.find(s, "\"", i)
		url = s[sp:ep]
	
		# If we have a URL, output it. If we've done
		# enough, quit the program
		if url != "":
			print "http:" + url
			linksOutput = linksOutput + 1
			if linksOutput == desiredLinks:
				sys.exit(0)
	
		i = string.find(s, "article.pl", i + 1)
	

if __name__ == "__main__":

	try:
		frontpage = sys.argv[1]
		desiredLinks = int(sys.argv[2])
		scrape()
		
	except IndexError:
		printUsage()
